%% MONOVARIATE SPECTRAL DECOMPOSITION
% JOHNSEN & ANDERSEN PER IL MODELLO AR - versione 2010, corretta da Baselli 1997

function [Sk,Sm,freq2,pot2,pot2n]=asd_ARMASpectDec(A,C,varw,fc,nfft)

%% carica serie
% clear;close all;clc;
% percorso='D:\SHARED\WIP\navy\test\Lelli\';% percorso dei dati da analizzare
% nome='rrsap_base.prn';
% p=7; %ordine modello AR
% xo=load([percorso nome]); xo=xo(:,1); x=xo-mean(xo);
% fc=1000/mean(xo); nfft=512;
% [Am,Su,Yp]=vlsMVAR(x,p);
% % [A,varw]=ar_coeff(x,p);
% varw=Su;
% A=[1 -Am];
% C=1;

%% poli, residui e potenze
poli=roots(A);
p=size(poli,1);
q=length(C);
%%% residui e potenze
res=NaN*ones(p,1);
for k=1:p
    pk=poli(k);
    zeta=NaN*ones(q,1); zeta1=zeta;
    z=pk; for kk=1:q, zeta(kk)=z^(-(kk-1)); end, Cz=C*zeta;
    z1=pk^(-1); for kk=1:q, zeta1(kk)=z1^(-(kk-1)); end, Cz1=C*zeta1;
    
%     z=pk; for kk=1:q, zeta(kk)=z^(-(kk-1)); end, Cz=C*zeta';
%     z1=pk^(-1); for kk=1:q, zeta1(kk)=z1^(-(kk-1)); end, Cz1=C*zeta1';
    
    tmp=poli;tmp(k)=[];%tutti i poli meno ilk-esimo
    res(k)=(Cz*varw*Cz1)/(pk*prod(pk-tmp)*prod(1/pk-poli));
end
pot=real(res);

%% estrazione poli da visualizzare
poli2=[];pot2=[];res2=[];
for n=1:p %considero solo i poli con frequenza tra 0 e 0.5 (escludo i coniugati per i poli "doppi")
    polo=poli(n); potenza=pot(n); residuo=res(n);
    if imag(polo)>=0
        poli2=[poli2; polo];
        res2=[res2; residuo];
        if imag(polo)==0
            pot2=[pot2; potenza];
        else
            pot2=[pot2; 2*potenza];
        end
    end
end
p2=length(poli2);


%% componenti spettrali
f = (0:nfft-1)*(fc/(2*nfft)); f=f';
z = exp(i*2*pi*f/fc); % vector of complex exponentials

poli2_=1./poli2;
res2_=-res2;
Sk=NaN*ones(nfft,p2); %Skm=Sk;
for k=1:p2 %realizza la (A.9) di Baselli 1997
    pk=poli2(k);resk=res2(k);
    pk_=poli2_(k);resk_=res2_(k);
    Sk(:,k)=(resk*pk./(z-pk)+resk_*pk_./(z-pk_))*2/fc; %riscalo in base alla frequenza di campionamento (per avere su Nyquist...)
    if imag(poli2(k))==0
        Sk(:,k)=real(Sk(:,k));
    else
        Sk(:,k)=2*real(Sk(:,k));
    end
end

freq2=angle(poli2).*(fc/(2*pi));
pot2n=100*pot2./sum(pot2);
Sm=sum(Sk,2);

%% graphs
% [Px,f2]=ar_spettro(A,varw,nfft,fc); %only for comparison
% Sm=sum(Sk,2);
% 
% figure('numbertitle','off','name','SPECTRAL DECOMPOSITION');
% subplot(2,1,1);plot(xo,'k');
% 
% subplot(2,1,2);
% plot(f,Px,'g:'); hold on;
% for k=1:p2
%     plot(f,Sk(:,k),'b:');
% end
% plot(f,Sm,'b');
% hold off;
% axis([0 fc/2 0 1.1*max(Sm)]);
%     
% 
% 
% [var(x) mean(Sm)*fc/2 sum(pot2)]
% % mean(Px)*fc/2
% % mean(Sm)*fc/2
% % sum(pot)
% % sum(pot2)
% 
% [freq2 pot2 pot2n]



