%% bootstrap for univariate AR residuals
% inputs:
% U, estimated residuals of AR model (in column)
% A, estimated coefficients of AR model (in column)
% Yi, initial p samples of the original time series (in column)

function outboot=idARboot(U,A,Yi)
  
    N=length(U)+size(Yi,1);
    p=size(A,1);
    Y=zeros(N,1);
    Y(1:p)=Yi; % initialization with first p original samples
      
    %AR filter to get bootstrapped time series
    for n=p+1:N 
        Y(n) = A' * Y(n-1:-1:n-p) + U(n-p);
    end
    
    % re-identification to get coeffs from bootstrapped time series
    [beAm,beSu]=idAR(Y,p,'y');
    
    outboot=[beAm' beSu];
end




